/**
 * Copyright (c) Navigraph. All rights reserved.
 *
 * This software is the property of Navigraph and may not be modified,
 * redistributed, or used for derivative works without explicit permission
 * from Navigraph, except for the following provision:
 *
 * You are permitted to modify the code solely for the purpose of enhancing
 * compatibility with Microsoft Flight Simulator, provided that such modifications
 * are limited to the specific functionality required for integration with Microsoft Flight Simulator.
 * Any other modifications, redistribution, or use for derivative works require
 * explicit permission from Navigraph.
 *
 * You may use this software solely for the purpose
 * of showing Navigraph Charts in Microsoft Flight Simulator.
 *
 * If you are interested in joining our team and contributing to projects
 * like this, please visit our careers page at https://careers.navigraph.com
 */


const shortcuts = {"shortcutKey":78,"useCtrl":true,"useShift":false,"useAlt":false};

(function($,r,j){"use strict";var U=(n=>(n[n.Waypoint=1]="Waypoint",n[n.Airway=2]="Airway",n[n.Error=0]="Error",n))(U||{});function b(n,e,t="",i=""){return`${n}${t.padEnd(2)}${i.padEnd(4)}${e.padEnd(5)}`}function K(n){const{facility:e,type:t,object_type:i}=n.item_data;return e&&i==="vhf_navaid"?"V":e&&i==="ndb_navaid"?"N":i==="airport"?"A":t==="I"?"U":"W"}var z=Object.defineProperty,q=(n,e,t)=>e in n?z(n,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):n[e]=t,G=(n,e,t)=>(q(n,typeof e!="symbol"?e+"":e,t),t),D=(n,e,t)=>new Promise((i,l)=>{var a=s=>{try{p(t.next(s))}catch(c){l(c)}},o=s=>{try{p(t.throw(s))}catch(c){l(c)}},p=s=>s.done?i(s.value):Promise.resolve(s.value).then(a,o);p((t=t.apply(n,e)).next())});class J{constructor(e){this.fms=e,G(this,"fpListenerInitialized",!1),G(this,"nonSyncableLegTypes",[r.LegType.Discontinuity,r.LegType.ThruDiscontinuity,r.LegType.Unknown,r.LegType.HM,r.LegType.HA,r.LegType.HF])}init(){return D(this,null,function*(){return new Promise(e=>{this.fpListenerInitialized?e():RegisterViewListener("JS_LISTENER_FLIGHTPLAN",()=>{this.fpListenerInitialized=!0,e()})})})}getSimFlightplan(){return D(this,null,function*(){return yield this.init(),yield Coherent.call("GET_FLIGHTPLAN")})}loadFromRouteInfo(e){return D(this,arguments,function*(t,i={}){var l,a,o,p,s,c,f,I,R,N,L;if(console.time("Flightplan import"),!t)throw new Error("Import failed. Failed to get route information");t.extras&&t.extras.cruiseAltitude&&this.setCruisingAltitude(t.extras.cruiseAltitude),this.fms.hasPrimaryFlightPlan()?yield this.fms.emptyPrimaryFlightPlan():yield this.fms.initPrimaryFlightPlan();const T=this.fms.facLoader,S=this.fms.getPrimaryFlightPlan(),M=(l=t.origin)==null?void 0:l.icao_code,w=(a=t.destination)==null?void 0:a.icao_code;if(!M||!w)throw new Error("Import failed. Failed to find associated airports");const[g,E]=yield Promise.all([T.getFacility(r.FacilityType.Airport,b("A",M)),T.getFacility(r.FacilityType.Airport,b("A",w))]);if(!g||!E)throw new Error("Import failed. Failed to find associated airports");this.fms.setOrigin(g),this.fms.setDestination(E),console.info("Importing flightplan from RouteInfo",{route:t});const _=g.departures.find(d=>{var h;return d.name===((h=t.sid)==null?void 0:h.identifier)});if(_&&i.loadProcedures){const d=(o=t.expanded_route_items)==null?void 0:o[0],h=(d==null?void 0:d.type)===U.Waypoint?d.item_data.ident:void 0,A=_.enRouteTransitions.findIndex(v=>v.name===h),m=(c=(s=(p=t.origin)==null?void 0:p.selected_runway)==null?void 0:s.replace("RW",""))!=null?c:"",y=r.RunwayUtils.matchOneWayRunwayFromDesignation(g,m);console.info("Inserting departure procedure",{departure:_,firstWpIdent:h,transitionIndex:A,originOneWayRunway:y}),this.fms.insertDeparture(g,g.departures.indexOf(_),y?this.getOneWayRunwayIndex(_,y):-1,A,y)}const C=E.arrivals.find(d=>{var h;return d.name===((h=t.star)==null?void 0:h.identifier)});if(C&&i.loadProcedures){const d=(f=t.expanded_route_items)==null?void 0:f[t.expanded_route_items.length-1],h=(d==null?void 0:d.type)===U.Waypoint?d.item_data.ident:void 0,A=C.enRouteTransitions.findIndex(v=>v.name===h),m=(N=(R=(I=t.destination)==null?void 0:I.selected_runway)==null?void 0:R.replace("RW",""))!=null?N:"",y=r.RunwayUtils.matchOneWayRunwayFromDesignation(E,m);console.info("Inserting arrival procedure",{arrival:C,lastWpIdent:h,transitionIndex:A,destinationOneWayRunway:y}),this.fms.insertArrival(E,E.arrivals.indexOf(C),y?this.getOneWayRunwayIndex(C,y):-1,A,y)}console.time("Loading facilities");const W=(L=t.compact_route_items)==null?void 0:L.map((d,h,A)=>D(this,null,function*(){switch(d.type){case U.Waypoint:{const{ident:m,icao_code:y,region_code:v,latitude:O,longitude:u}=d.item_data,F=K(d);if(F==="U"){const H=r.UserFacilityUtils.createFromLatLon(`U      USR${h.toString().padStart(2,"0")}`,O,u,!0,m);return this.fms.addUserFacility(H),H}const X=b(F,m,y,v);return T.getFacility(r.FacilityType.Intersection,X).catch(()=>{const H=r.ICAO.getFacilityType(F);return T.getFacility(H,X)})}case U.Airway:{if(d.item_data.airway_ident==="DCT"||!i.loadAirways)return;const m=A[h-1],y=A[h+1],v=[m,y].find(F=>(F==null?void 0:F.type)===U.Waypoint);if(!v)return;const O=v.item_data.facility?"V":"W",u=b(O,v.item_data.ident,v.item_data.icao_code);return yield T.getAirway(d.item_data.airway_ident,0,u).catch(console.error)}}})),x=yield Promise.all(W!=null?W:[]);console.timeEnd("Loading facilities");for(const[d,h]of x.entries()){if(!h)continue;const A=x[d-1],m=x[d+1],y=A&&"routes"in A,v=m&&"routes"in m,O=this.fms.findLastEnrouteSegmentIndex(S),u=S.getSegment(O).legs.length;h instanceof r.AirwayObject&&y&&v&&this.fms.insertAirwaySegment(h,A,m,O,u),h instanceof r.AirwayObject||this.fms.insertWaypoint(O,h)}console.timeEnd("Flightplan import"),this.saveToGame()})}saveToGame(){return D(this,null,function*(){var e,t,i;const l=this.fms;if(!l.hasPrimaryFlightPlan())return;const a=f=>console.error("Error saving flightplan to simulator:",f instanceof Error?f.message:JSON.stringify(f)),o=l.flightPlanner.getActiveFlightPlan();yield Coherent.call("SET_CURRENT_FLIGHTPLAN_INDEX",0,!1).catch(a),yield Coherent.call("CLEAR_CURRENT_FLIGHT_PLAN").catch(a),o.originAirport!==void 0&&o.originAirport.length>0&&(yield Coherent.call("SET_ORIGIN",o.originAirport,!1).catch(a)),o.destinationAirport!==void 0&&o.destinationAirport.length>0&&(yield Coherent.call("SET_DESTINATION",o.destinationAirport,!1).catch(a)),o.procedureDetails.originRunway&&(yield Coherent.call("SET_ORIGIN_RUNWAY_INDEX",(e=o.procedureDetails.originRunway)==null?void 0:e.parentRunwayIndex).catch(a)),yield Coherent.call("SET_DEPARTURE_RUNWAY_INDEX",o.procedureDetails.departureRunwayIndex).catch(a),yield Coherent.call("SET_DEPARTURE_PROC_INDEX",o.procedureDetails.departureIndex).catch(a),yield Coherent.call("SET_DEPARTURE_ENROUTE_TRANSITION_INDEX",(t=o.procedureDetails.departureTransitionIndex)!=null?t:-1).catch(a);const p=o.segmentsOfType(r.FlightPlanSegmentType.Enroute),s=o.segmentsOfType(r.FlightPlanSegmentType.Departure);let c=0;for(const f of s)c+=f.legs.length;for(const f of p)for(const I of f.legs){if(!this.isSyncableLeg(I.leg))return;try{const R=r.ICAO.getFacilityType(I.leg.fixIcao);if(R===r.FacilityType.USR){const N=yield l.facLoader.getFacility(R,I.leg.fixIcao);yield Coherent.call("ADD_CUSTOM_WAYPOINT",(i=I.name)!=null?i:I.leg.fixIcao,c,N.lat,N.lon,!1)}else yield Coherent.call("ADD_WAYPOINT",I.leg.fixIcao,c,!1);c++}catch(R){console.warn(`Error during fp sync: ${JSON.stringify(R)}`)}}yield Coherent.call("SET_ARRIVAL_RUNWAY_INDEX",Math.max(o.procedureDetails.arrivalRunwayTransitionIndex,0)).catch(a),yield Coherent.call("SET_ARRIVAL_PROC_INDEX",o.procedureDetails.arrivalIndex).catch(a),yield Coherent.call("SET_ARRIVAL_ENROUTE_TRANSITION_INDEX",o.procedureDetails.arrivalTransitionIndex).catch(a),yield Coherent.call("SET_APPROACH_INDEX",o.procedureDetails.approachIndex).then(()=>Coherent.call("SET_APPROACH_TRANSITION_INDEX",o.procedureDetails.approachTransitionIndex)).catch(a),Coherent.call("RECOMPUTE_ACTIVE_WAYPOINT_INDEX",1).catch(a)})}isSyncableLeg(e){return this.nonSyncableLegTypes.indexOf(e.type)===-1}getOneWayRunwayIndex(e,{direction:t,runwayDesignator:i}){return e.runwayTransitions.findIndex(l=>l.runwayNumber===t&&l.runwayDesignation===i)}setCruisingAltitude(e){e=Utils.Clamp(e,0,1e5),Coherent.call("FP_UPDATE_ALTITUDE",e).catch(t=>console.error("Failed to set cruising altitude",t))}}var Z=Object.defineProperty,Q=(n,e,t)=>e in n?Z(n,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):n[e]=t,V=(n,e,t)=>(Q(n,typeof e!="symbol"?e+"":e,t),t),Y=(n,e,t)=>new Promise((i,l)=>{var a=s=>{try{p(t.next(s))}catch(c){l(c)}},o=s=>{try{p(t.throw(s))}catch(c){l(c)}},p=s=>s.done?i(s.value):Promise.resolve(s.value).then(a,o);p((t=t.apply(n,e)).next())});class k{constructor(e){this.fplManager=e,V(this,"guid",r.UUID.GenerateUuid()),V(this,"hasFocus",!1),V(this,"dataStorageStartup",new Promise(t=>RegisterViewListener("JS_LISTENER_DATASTORAGE",()=>{console.info("Data storage is ready!"),t()})))}init(){window.addEventListener("message",this.handlePanelEvent.bind(this))}handlePanelEvent({data:e,ports:[t]}){switch(e.action){case"SET_VALUE":return this.handleSetValue(e.payload);case"GET_VALUE":return t?this.handleGetValue(e.payload,t):void 0;case"KEYDOWN_EVENT":return document.dispatchEvent(new KeyboardEvent("keydown",e.payload));case"OPEN_URL":return this.handleOpenURL(e.payload);case"FOCUS_EVENT":return this.handleFocusEvent(e.payload);case"IMPORT_FLIGHTPLAN":{console.info("%cReceived flightplan import request","background: rgb(25, 34, 48); color: white; border-radius: 3px; padding: 3px;"),console.info(e.payload),this.fplManager.loadFromRouteInfo(e.payload,{loadAirways:!0,loadProcedures:!0}).catch(console.error);break}case"LOG":return console.log(`[Navigraph Charts] ${e.payload}`);default:console.warn("Received non-registered event: "+JSON.stringify(e))}}handleSetValue(e){return Y(this,arguments,function*({key:t,value:i}){yield this.dataStorageStartup,SetStoredData(t,String(i)),console.info(`Key: ${t} set to ${i}`)})}handleGetValue(e,t){return Y(this,arguments,function*({key:i},l){yield this.dataStorageStartup;const a=GetStoredData(i);l.postMessage(a),console.info(`Key: ${i} requested, returning ${a}`)})}handleOpenURL(e){console.info(`Opening URL: ${e}`),OpenBrowser(e)}handleFocusEvent(e){if(e==="focus"&&this.hasFocus||e==="blur"&&!this.hasFocus){console.info(`Panel is alread in state '${e}', ignoring event with same state`);return}e==="focus"?(this.hasFocus=!0,Coherent.trigger("FOCUS_INPUT_FIELD",this.guid,"","","",!1),Coherent.on("mousePressOutsideView",()=>this.handleFocusEvent("blur"))):(this.hasFocus=!1,Coherent.trigger("UNFOCUS_INPUT_FIELD",this.guid),Coherent.off("mousePressOutsideView")),console.info("Changed focus state to: "+e)}}function ee(n,e){const t=B(n,!1),i=B(e,!0);return`${t}${i}`}function B(n,e){const t=Math.abs(n),i=Math.floor(t),l=Math.floor((t-i)*60),a=Math.round((t-i-l/60)*3600),o=e?n>=0?"E":"W":n>=0?"N":"S";return`${String(i).padStart(e?3:2,"0")}${String(l).padStart(2,"0")}${String(a).padStart(2,"0")}${o}`}var te=(n,e,t)=>new Promise((i,l)=>{var a=s=>{try{p(t.next(s))}catch(c){l(c)}},o=s=>{try{p(t.throw(s))}catch(c){l(c)}},p=s=>s.done?i(s.value):Promise.resolve(s.value).then(a,o);p((t=t.apply(n,e)).next())});class ie{static serializeFlightPlan(e,t){return te(this,null,function*(){var i,l;const{waypoints:a,departureRunwayIndex:o,departureProcIndex:p,departureEnRouteTransitionIndex:s,arrivalRunwayIndex:c,arrivalProcIndex:f,arrivalEnRouteTransitionIndex:I,approachIndex:R,approachTransitionIndex:N}=e;if(a.length===0)return{origin:void 0,destination:void 0,route:void 0};const L=a[0],T=a[a.length-1],S=L&&r.ICAO.isFacility((i=L==null?void 0:L.icao)!=null?i:"",r.FacilityType.Airport),M=T&&r.ICAO.isFacility((l=T==null?void 0:T.icao)!=null?l:"",r.FacilityType.Airport),[w,g]=yield Promise.all([S?t.facLoader.getFacility(r.FacilityType.Airport,L.icao):void 0,M?t.facLoader.getFacility(r.FacilityType.Airport,T.icao):void 0]),E=w==null?void 0:w.departures[p],_=g==null?void 0:g.arrivals[f],C=g==null?void 0:g.approaches[R],W=E&&$.FmsUtils.getDepartureEnrouteTransitionName(E,s,o),x=_&&$.FmsUtils.getArrivalEnrouteTransitionName(_,I,c),d=E?E.runwayTransitions[o]:void 0,h=u=>{try{u.ident==="Custom"?u.ident=ee(u.lla.lat,u.lla.long):r.ICAO.isFacility(u.icao,r.FacilityType.Airport)&&(u.ident=r.ICAO.getIdent(u.icao))}catch(F){console.error("Error thrown while formatting waypoint: ",F)}return`${u.ident} ${u.airwayIdent?u.airwayIdent+" ":""}`},A=a.filter(u=>r.ICAO.isFacility(u.icao)||u.ident==="Custom").slice(Math.max(e.departureWaypointsSize,0),a.length-Math.max(e.arrivalWaypointsSize,0)).map(h).join(" "),m=d?r.RunwayUtils.getRunwayNameString(d.runwayNumber,d.runwayDesignation,!0):void 0,y=w?[r.ICAO.getIdent(w.icao),m||void 0].filter(u=>!!u).join("/"):void 0,v=C?this.getNavigraphApproachString(C,N):void 0,O=g?[r.ICAO.getIdent(g.icao),v||void 0].filter(u=>!!u).join("/"):void 0;return{origin:w?r.ICAO.getIdent(w.icao):void 0,destination:g?r.ICAO.getIdent(g.icao):void 0,route:[y,E==null?void 0:E.name,W,A,x,_==null?void 0:_.name,O].filter(u=>!!u).join(" ")}})}static getNavigraphApproachString(e,t=-1){const i=e==null?void 0:e.transitions[t],l=this.getApproachTypeLetter(e.approachType,e.name),a=r.RunwayUtils.getRunwayNameString(e.runwayNumber,e.runwayDesignator,!0);return`${i?i.name+".":""}${l}${a.padEnd(3,"-")}${e.approachSuffix}`}static getApproachTypeLetter(e,t){switch(e){case ApproachType.APPROACH_TYPE_GPS:return"P";case ApproachType.APPROACH_TYPE_VOR:return"V";case ApproachType.APPROACH_TYPE_NDB:return"N";case ApproachType.APPROACH_TYPE_ILS:return"I";case ApproachType.APPROACH_TYPE_LOCALIZER:return"L";case ApproachType.APPROACH_TYPE_SDF:return"U";case ApproachType.APPROACH_TYPE_LDA:return"X";case ApproachType.APPROACH_TYPE_VORDME:return"D";case ApproachType.APPROACH_TYPE_NDBDME:return"Q";case ApproachType.APPROACH_TYPE_RNAV:return"R";case ApproachType.APPROACH_TYPE_LOCALIZER_BACK_COURSE:return"B";case ApproachType.APPROACH_TYPE_UNKNOWN:case r.AdditionalApproachType.APPROACH_TYPE_VISUAL:default:return console.error("Unknown approach encountered:",{type:e,name:t}),""}}}var ne=Object.defineProperty,ae=(n,e,t)=>e in n?ne(n,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):n[e]=t,P=(n,e,t)=>(ae(n,typeof e!="symbol"?e+"":e,t),t),re=(n,e,t)=>new Promise((i,l)=>{var a=s=>{try{p(t.next(s))}catch(c){l(c)}},o=s=>{try{p(t.throw(s))}catch(c){l(c)}},p=s=>s.done?i(s.value):Promise.resolve(s.value).then(a,o);p((t=t.apply(n,e)).next())});class oe extends UIElement{constructor(){super(...arguments),P(this,"panel_id","NAVIGRAPH_CHARTS_PANEL"),P(this,"ingameUi"),P(this,"iframeElement"),P(this,"bus",new r.EventBus),P(this,"loader",new r.FacilityLoader(r.FacilityRepository.getRepository(this.bus))),P(this,"calculator",new r.FlightPathCalculator(this.loader,{defaultClimbRate:300,defaultSpeed:60,bankAngle:[[10,60],[25,180]],holdBankAngle:null,courseReversalBankAngle:null,turnAnticipationBankAngle:[[10,60],[15,100]],maxBankAngle:25,airplaneSpeedMode:r.FlightPathAirplaneSpeedMode.TrueAirspeedPlusWind},this.bus)),P(this,"planner",r.FlightPlanner.getPlanner(this.bus,this.calculator)),P(this,"fms",new $.Fms(!1,this.bus,this.planner)),P(this,"fplManager",new J(this.fms)),P(this,"panelEventBus",new k(this.fplManager)),P(this,"flightplanPromise",this.fplManager.getSimFlightplan().then(e=>re(this,null,function*(){return ie.serializeFlightPlan(e,this.fms)})))}connectedCallback(){var e,t;if(super.connectedCallback(),this.panelEventBus.init(),this.ingameUi=(e=this.querySelector("ingame-ui"))!=null?e:void 0,this.iframeElement=(t=document.querySelector("#navigraph-charts-iframe"))!=null?t:void 0,!this.ingameUi||!this.iframeElement)throw new Error("Panel elements missing");this.iframeElement.src||this.initCharts()}initCharts(){if(!this.iframeElement)return console.error("No iframe element found");console.info("Initializing..."),this.iframeElement.src="https://chartspanel-v8.devigraph.com",this.iframeElement.addEventListener("load",e=>this.handleIframeLoad(e.target))}handleIframeLoad(e){var t;console.info("Iframe loaded"),this.addShortcutListener(),this.addScreenHeightListener(),e.style.opacity="1";const i=(t=this.ingameUi)==null?void 0:t.querySelector(".loading_container");i&&(i.style.opacity="0",setTimeout(()=>i==null?void 0:i.remove(),500)),this.flightplanPromise.then(l=>{var a,o;console.info(l.route?`Route detected: ${l.route}`:"No route detected"),(o=(a=this.iframeElement)==null?void 0:a.contentWindow)==null||o.postMessage({action:"LOAD_FLIGHTPLAN",payload:l},"*")}).catch(console.error)}addShortcutListener(){document.addEventListener("keydown",e=>{const{shortcutKey:t,useAlt:i,useCtrl:l,useShift:a}=j,o=(l?e.ctrlKey:!0)&&(i?e.altKey:!0)&&(a?e.shiftKey:!0);this.ingameUi&&e.keyCode===t&&o&&(this.ingameUi.visible=!this.ingameUi.visible,this.ingameUi.active=this.ingameUi.visible,this.ingameUi.visible?this.handlePanelActive():this.handlePanelInactive())})}addScreenHeightListener(){const e=document.documentElement;let t="";const i=()=>{var l,a;const o=e.style.getPropertyValue("--screenHeight");t!==o&&(t=o,(a=(l=this.iframeElement)==null?void 0:l.contentWindow)==null||a.postMessage({action:"SCREEN_HEIGHT_CHANGED",payload:parseInt(t)},"*"))};new MutationObserver(()=>i()).observe(document.documentElement,{attributes:!0,attributeFilter:["style"]}),i()}handlePanelActive(){var e;if(console.info("Panel active"),!this.ingameUi||!this.iframeElement)return;const t=this.ingameUi.classList.contains("minimized"),i=t?"PAUSE_MOVING_MAP":"RESUME_MOVING_MAP";console.info(`${t?"Pausing":"Resuming"} Moving Map`),(e=this.iframeElement.contentWindow)==null||e.postMessage({action:i},"*")}handlePanelInactive(){var e;console.info("Panel Inactive"),this.iframeElement&&(console.info("Pausing Moving Map"),(e=this.iframeElement.contentWindow)==null||e.postMessage({action:"PAUSE_MOVING_MAP"},"*"))}}window.customElements.define("navigraph-panel",oe)})(garminsdk,msfssdk,shortcuts);
